=== debian/changelog ===
watchman (4.9.0-8build1) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 05 Mar 2025 01:18:37 +0000

watchman (4.9.0-8) unstable; urgency=medium

  * QA Upload
  * Use dh-sequence-python3
  * Add build-dep on python3-setuptools (Closes: #1080829)

 -- Alexandre Detiste <tchet@debian.org>  Sun, 19 Jan 2025 21:23:12 +0100

watchman (4.9.0-7) unstable; urgency=medium

  * Bumped up standards version. 
  * Fix issue with Python 3.10, patch by Frederic Peters (Closes: #1008964)
  * Removed unnecessary lintian overrides
  * Added reproducibility flags
  * Orphaning package and setting maintainer to Debian QA

 -- Anuradha Weeraman <anuradha@debian.org>  Sat, 10 Sep 2022 16:25:54 +0530

watchman (4.9.0-6) unstable; urgency=high

  * Fix FTBFS with autoconf 2.71 (Closes: #978921)
  * Bumped up Standards Version to 4.6.0

 -- Anuradha Weeraman <anuradha@debian.org>  Tue, 24 Aug 2021 20:15:54 +0530

watchman (4.9.0-5) unstable; urgency=high

  [ Debian Janitor ]
  * Use secure URI in Homepage field.
  * Remove obsolete field Name from debian/upstream/metadata (already present in
    machine-readable debian/copyright).

  [ Anuradha Weeraman ]
  * Resolve FTBFS due to version constraint on python3-all-dev (Closes: #975746)
  * Bumped up standards version

 -- Anuradha Weeraman <anuradha@debian.org>  Wed, 25 Nov 2020 19:03:07 -0500

watchman (4.9.0-4) unstable; urgency=medium

  * Bumped up standards version
  * Included upstream metadata
  * Enabled reproducibility testing in the Salsa CI pipeline
  * Lintian fixes
  * Fix for auto-upperlimit-python3 transition

 -- Anuradha Weeraman <aweeraman@gmail.com>  Sat, 01 Feb 2020 18:09:00 -0500

watchman (4.9.0-3) unstable; urgency=medium

  * Respect TMPDIR for state (Closes: #946544)

 -- Anuradha Weeraman <aweeraman@gmail.com>  Tue, 31 Dec 2019 17:12:19 -0500

watchman (4.9.0-2) unstable; urgency=low

  * Bumped up standards version
  * Build python modules for all supported python3 versions

 -- Anuradha Weeraman <aweeraman@gmail.com>  Mon, 11 Nov 2019 16:02:18 -0500

watchman (4.9.0-1) unstable; urgency=low

  * Initial release. Closes: #740691

 -- Anuradha Weeraman <aweeraman@gmail.com>  Wed, 02 Oct 2019 11:24:37 -0400
