=== debian/control ===
Source: watchman
Section: utils
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper (>=12~),
               debhelper-compat (=12),
               dh-sequence-python3,
               python3-all-dev,
               python3-setuptools,
               pkgconf,
               libpcre3-dev,
               libssl-dev
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/debian/watchman
Vcs-Git: https://salsa.debian.org/debian/watchman.git
Homepage: https://facebook.github.io/watchman
Rules-Requires-Root: no

Package: watchman
Architecture: linux-any
Suggests: python3-pywatchman
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: File watching service
 Watchman can be used to watch files and record when they actually change.
 It can be used to trigger actions (such as rebuilding assets) when
 matching files change. If you require to perform an action based on
 whether a file changes or not, watchman may be the tool you need. By
 giving watchman a pattern and an action to take when the files change,
 you can trigger an activity to be taken.

Package: python3-pywatchman
Section: python
Architecture: linux-any
Provides: ${python3:Provides}
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}, watchman
Description: Python library for Watchman and related utilities
 A Python library for watchman (the file watching service), and related
 utilities such as watchman-make and watchman-wait. Watchman can be used
 to watch files and record when they actually change. It can be used
 to trigger actions (such as rebuilding assets) when matching files
 change. If you require to perform an action based on whether a file
 changes or not, watchman may be the tool you need. By giving watchman
 a pattern and an action to take when the files change, you can trigger
 an activity to be taken.
